(function () {
    "use strict";

    angular.module('core').controller('movimentacaoContaController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$stateParams', '$alert', 'movimentacaoContaService', 'lookupService'];

    function controller($scope, $timeout, $q, $stateParams, $alert, movimentacaoContaService, lookupService) {
        $scope.initializeLayout('Movimentação de Contas');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: { ativo: false, args: null },
        };
        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function () {
                    $scope.state.salvando = true;
                    movimentacaoContaService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $scope.refresh();
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }
                },
                prepare: function () {
                    movimentacaoContaService
                        .prepareNew($scope.auxiliar.contaContabil.selected)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.edit.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ativo = true;
                                }
                            },
                            function (_error) {
                                $scope.popups.edit.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
            },
            edit: {
                ativo: false,
                data: {},
                save: function () {
                    $scope.state.salvando = true;
                    movimentacaoContaService
                        .save($scope.popups.edit.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.popups.edit.ativo = false;
                                    $scope.popups.edit.data = {};
                                    $scope.refresh();
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                toggle: function (id) {
                    $scope.popups.edit.ativo = !$scope.popups.edit.ativo
                    if ($scope.popups.edit.ativo && id) {
                        $scope.popups.edit.prepare(id);
                    }
                },
                prepare: function (id) {
                    var args = { id: id };
                    movimentacaoContaService
                        .get(args)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                    $scope.popups.edit.ativo = false;
                                } else {
                                    $scope.popups.edit.data = response.Data;
                                    $scope.popups.edit.ativo = true;
                                }
                            },
                            function (_error) {
                                $scope.popups.edit.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                delete: function (id) {
                    $scope.state.salvando = true;
                    movimentacaoContaService
                        .delete(id)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.popups.edit.ativo = false;
                                    $scope.popups.edit.data = {};
                                    $scope.refresh();
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
            },
        };
        $scope.auxiliar = {
            contaContabil: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContaContabil({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
                selected: null
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.clearFilter();
            if ($stateParams.id)
                $scope.popups.edit.toggle($stateParams.id);
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            $scope.state.scroll = $scope.tools.getScrollPosition();

            movimentacaoContaService
                .getAllComSaldo($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                            $scope.tools.setScrollPosition($scope.state.scroll);

                            localStorage.setItem('state.filtro.args.contaAnaliticaID', $scope.state.filtro.args.contaAnaliticaID);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = (!angular.isArray($scope.state.data) || $scope.state.data.length === 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
        };

        $scope.clearFilter = function () {
            var contaAnaliticaID = localStorage.getItem('state.filtro.args.contaAnaliticaID');
            if (!contaAnaliticaID)
                contaAnaliticaID = '11111111-1111-0000-0000-000000000000';

            $scope.state.filtro.args = { contaAnaliticaID: contaAnaliticaID, dataDe: $scope.tools.getHoje(), dataAte: $scope.tools.getHoje() };

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    };

})();